// component/cardModal/cardModal.js
const app = getApp();
const wxService = require('../../utils/wxService')
const utils = require('../../utils/util')
const envInfo = require('../../config/index').envInfo

Component({
  /**
   * 组件的属性列表
   */
  properties: {
    showCardModal:{
      type: Boolean,
      value: ''
    },
    cardTitle: {
      type: String,
      value: ''
    },
    cardUrl: {
      type: String,
      value: ''
    },
    cardExplain: {
      type: String,
      value: ''
    },
    pagePath: {
      type: String,
      value: ''
    },
    scene: {
      type: String,
      value: ''
    },
    product : {
      type : Object,
      value : null
    }
  },
  observers: {
    cardExplain(ex) {
      this.setData({explainList:ex ? JSON.parse(ex) : []})
    }
  },
  /**
   * 组件的初始数据
   */
  data: {
    codeImg:'',
    explainList: [],
    shareLogo: envInfo.shareLogo,
    shareTitle: envInfo.shareTitle,
  },

  /**
   * 组件的方法列表
   */
  methods: {
    //跳转到海报页面
    gotoPoster(){
      // this.setData({
      //   showCardModal:false
      // })
      wx.showLoading({
        title: '跳转中..',
      });
      this.getMiniCode();
    },

    //获取二维码
    getMiniCode() {
      const urls = utils.getCurrentPageUrlWithArgs()
      const page = urls && urls.split("?")[0]

      let data = {
        "autoColor": true,
        "page": this.data.pagePath,
        "scene": this.data.scene,
        "width": 100
      }

      wxService.post(`/marketing/quickMark/getAppQrCodePicture`, data).then(res => {
        wx.hideLoading();
        const { result, data } = res.data
        if (result == 0) {
          this.setData({
            codeImg: app.globalData.imageUrl + data
            // codeImg: "https://hwimagecdn.ihotwind.cn/usr/201908/miniQrCode-f00c5051fef7479395efb193431762c4.jpg"
          })
          console.log(this.data.codeImg)
          if (this.data.codeImg) {
            // this.selectComponent('#getPoster').getAvaterInfo()
            if (this.data.product){
              let obj = {
                productName: this.data.cardTitle,
                minSalePrice: this.data.product.minSalePrice,
                productImg: this.data.cardUrl,
                qrcodeImg: this.data.codeImg,
                type: this.data.product.type
              };
              wx.setStorageSync('shareInfo', obj)
              wx.navigateTo({
                url: '/subPackage/page/pages/shareConfig/shareConfig',
              });
            }
            else{
              let obj =  {
                productName: this.data.cardTitle,
                productImg: this.data.cardUrl,
                qrcodeImg: this.data.codeImg,
              }

              wx.setStorageSync('shareArticle', obj)
              wx.navigateTo({
                url: '/subPackageA/page/pages/shareArticle/shareArticle',
              });
            }
            
          }
        }
      })
    },

    _showMiniCard(e){
      console.log(e)
      this.setData({
        showCardModal: true
      })
    },

    closeCardModal(){
      this.setData({
        showCardModal: false
      })
    }

  }
})
