// components/floatNav/floatNav.js
var app = getApp()
const wxService = require('../../utils/wxService')
const utils = require('../../utils/util')
const utilLink = require('../../utils/currentLinkRouter')
const envInfo = require('../../config/index').envInfo
Component({
  /**
   * 组件的属性列表
   */
  properties: {

  },
  
  // { path: '', icon: 'https://bigaka-xie.oss-cn-shanghai.aliyuncs.com/home.png', animationObj: {}, type: '', title: '主页' },
  // { path: '', icon: 'https://bigaka-xie.oss-cn-shanghai.aliyuncs.com/category.png', animationObj: {}, type: '', title: '分类' },
  // { path: '', icon: 'https://bigaka-xie.oss-cn-shanghai.aliyuncs.com/order.png', animationObj: {}, type: '', title: '我的订单' },
  // { path: '', icon: 'https://bigaka-xie.oss-cn-shanghai.aliyuncs.com/my.png', animationObj: {}, type: '', title: '我的' },
  // { path: '', icon: 'https://bigaka-xie.oss-cn-shanghai.aliyuncs.com/cart.png', animationObj: {}, type: '', title: '购物车' }
  
  /**
   * 组件的初始数据
   */
  data: {
    isPopping: false,//是否已经弹出
    navBars: [],
    animMenu: {},
    userIsLogin : false,
  },

  attached(){
    console.log('attached')
  },
  lifetimes: {
    ready() {
      console.log(123123)
      this.userHasLogined();
      this.getPageConfig();
    }
  },  

  /**
   * 组件的方法列表
   */
  methods: {
    _getUserInfo(res = {}) {
      this.triggerEvent('getAuth', res);
    },
    //获取页面配置信息
    getPageConfig(){
      if (envInfo.isMall){
        let navBars = wx.getStorageSync('navBars');
        if (navBars){
          let tabBar = navBars.tabBar;
          let currentTab = tabBar.images
          currentTab.forEach(item => {
            // 存在 row 处理数据 8 商品 9 分类
            // 1. 外部小程序_url  2. 内部动态页面_pageId  3.预览  4. 内部页面 5. 卡券__1_卡包 2_激活领卡
            let newRow = null
            if (item.link) {
              if (item.link.type == 2) {
                // 父组件 更新
                const urls = getCurrentPages()
                const currentPath = urls[0]
                const pageId = item.link.url
                item.link.newPath = `/${currentPath.route}`
              }
              return
            } else if (item.row) {
              newRow = JSON.parse(item.row)
              if (newRow.type == 8) {
                newRow.newPath = '/pages/productDetail/productDetail'
              } else if (newRow.type == 9) {
                newRow.newPath = '/subPackage/page/pages/categoryPro/categoryPro'
              }
              item.row = newRow
            }
          });

          //处理是否授权了
          // 当前匹配路径是否需要授权 true 需要 false 不需要
          currentTab.forEach(item => {
            let checkUrl = ''
            if (item.link) {
              checkUrl = item.link.newPath ? item.link.newPath : item.link.url
            } else if (item.row) {
              checkUrl = item.row.newPath ? item.row.newPath : item.row.url
            }
            wxService.NoLoginPage(checkUrl).then(res => {
              if (checkUrl) item.needAuth = res.needAuth;
              this.setData({ navBars: currentTab })
            });
          });
        }
        else{
          this.setData({
            navBars: [],
          })
        }
      }
    },
    //判断用户是否已经登录
    userHasLogined(){
      const baseUserInfo = wx.getStorageSync('_baseUserInfo')
      if (baseUserInfo && wx.getStorageSync('token')) {
        this.setData({
          userIsLogin : true
        });
      }
      else{
        userIsLogin : false
      }
    },
    //点击弹出
    bindShowOrCloseMenu: function () {
      if (this.data.isPopping) {
        //缩回动画
        this.closeAnimation();
        this.setData({
          isPopping: false
        })
      } else if (!this.data.isPopping) {
        //弹出动画
        this.popAnimation();
        this.setData({
          isPopping: true
        });
      }
    },
    //点击menu
    bindNav(event) {
      console.log(event)
      utilLink.currentLinkRouter(event, this)
    },
    //弹出nav动画
    popAnimation() {
      let len = this.data.navBars.length;
      this.data.navBars.forEach((item, index) => {
        let animationContext = wx.createAnimation({
          duration: 500,
          timingFunction: 'ease-out'
        });

        this.handlerAnimation(len, index, animationContext);

        item.animationObj = animationContext.export();
      });

      //plus顺时针旋转
      var animationMenu = wx.createAnimation({
        duration: 500,
        timingFunction: 'ease-out'
      })

      animationMenu.rotateZ(360).step();

      this.setData({
        animMenu: animationMenu.export(),
        navBars: this.data.navBars
      });
    },
    //关闭nav动画
    closeAnimation() {
      //plus顺时针旋转
      var animationMenu = wx.createAnimation({
        duration: 500,
        timingFunction: 'ease-out'
      })

      this.data.navBars.forEach((item, index) => {
        let animationContext = wx.createAnimation({
          duration: 500,
          timingFunction: 'ease-out'
        });

        animationContext.translate(0, 0).rotateZ(0).opacity(0).step();
        item.animationObj = animationContext.export();
      });

      animationMenu.rotateZ(0).step();
      this.setData({
        animMenu: animationMenu.export(),
        navBars: this.data.navBars
      });
    },
    //处理动画逻辑分4个和5个时
    handlerAnimation(len, index, animationContext) {
      // const translateFour = [[-50, -30], [-80, 20], [-80, 80], [-50, 130]];
      // const translateFive = [[-50, -45], [-90, 0], [-110, 55], [-90, 112], [-50, 155]];
      const translateFour = [[-50, -80], [-80, -30], [-80, 30], [-50, 80]];
      const translateFive = [[-50, -100], [-90, -55], [-110, 0], [-90, 55], [-50, 100]];

      if (len == 4) {
        animationContext.translate(translateFour[index][0], translateFour[index][1]).rotateZ(360).opacity(1).step();
      }
      else if (len == 5) {
        animationContext.translate(translateFive[index][0], translateFive[index][1]).rotateZ(360).opacity(1).step();
      }
    },
  }
})
