// component/goHome/goHome.js
var app = getApp()
const wxService = require('../../utils/wxService')
const utils = require('../../utils/util')
const envInfo = require('../../config/index').envInfo

Component({
	/**
	 * 组件的属性列表
	 */
  properties: {

  },
  attached() {

  },
	/**
	 * 组件的初始数据
	 */
  data: {
    showGoGuid : false
  },
  lifetimes:{
    ready(){
      console.log('组件ready')
      //获取当前环境是不是企业微信
      const currentEnv = wx.getStorageSync('_qyWeChat') ? wx.getStorageSync('_qyWeChat') : null;
      const loginUserInfo = wx.getStorageSync('_baseUserInfo') ? wx.getStorageSync('_baseUserInfo') : null;
      if (currentEnv && loginUserInfo){
        console.log(loginUserInfo)
        let qiyeInfo = loginUserInfo.member.qiyeInfo ? loginUserInfo.member.qiyeInfo : null;
        if (!qiyeInfo){
          this.setData({
            showGoGuid: false
          });
          return 
        }

        if (Object.keys(qiyeInfo).length == 0){
          this.setData({
            showGoGuid: false
          });

          return ;
        }

        this.setData({
          showGoGuid: true
        });
      }
      else{
        this.setData({
          showGoGuid : false
        });
      }
    },
  },  
	/**
	 * 组件的方法列表
	 */
  methods: {
    handelGoGuid() {
      //获取当前页面栈
      let pages = getCurrentPages();
      let currentPage = pages[pages.length - 1];
      let guidpageIndex = undefined;
      //找一下当前栈中是不是有导购首页
      pages.forEach((item,index) => {
        if (item.route == 'shoppingGuid/page/pages/home/home'){
          guidpageIndex = index;
        }
      });

      //说明没有从导购那边进到商城这边来，那就直接进到导购页面
      if(guidpageIndex === undefined){
        wx.reLaunch({
          url: '/shoppingGuid/page/pages/home/home',
        });
        return ;
      }

      //说明是从导购那边过来的 关闭之间的页面
      wx.navigateBack({
        delta: pages.length - guidpageIndex,
      });
      
    }
  }
})
