// component/personCenter/personCenter.js
var app = getApp()
const wxService = require('../../utils/wxService')
const envInfo = require('../../config/index').envInfo

Component({
  properties: {
    currentHasUserInfo: {
      type: Boolean,
      type: false
    },
    personData: {
      type: Object,
      value: {},
    },
    integralNum: {
      type: Number,
      value: 0,
    },
    // cardMember: {
    //   type: Object,
    //   value: {},
    // },
    baseUserInfo: {
      type: Object,
      value: {},
      observer: '_userInfoChange'
    },
    couponNum: {
      type: Number,
      value: 0,
    },
    valueCardNum : {
      type: Number,
      value: 0,
    },
    token: {
      type: String,
      observer(newVal) {
        this.setData({
          _token: newVal
        })
      }
    },
    isVip: {
      type: Boolean,
      type: false
    }
  },
  /**
   * 页面的初始数据
   */
  data: {
    personCenter: {},
    memberCardNo: "",
    memberActivateStatus: false,
    integralNum: 0,
    couponNum: 0,
    valueCardNum: 0,
    // baseUrl: '/assets/imgs/060610.png',
    baseUrl: '#02bb70',
    isAuthorization: false,
    _token: '',
    currentMobile: '',
    baseImgUrl: app.globalData.imageUrl,
    storgeUserInfo: wx.getStorageSync('_baseUserInfo'),
    isPlusVip: false,
    currentPlusStyle: null,
    memberIsOpen : false,
    levelName : ''
  },
  observers: {
    '**': function (e) {
      // 每次 setData 都触发
    },
  },
  attached() {
    // console.log("isvip", this.data.isVip)
    const { imageUrl } = app.globalData
    const { personData, isVip } = this.data
    this.setData({
      personCenter: personData,
      baseImgUrl: imageUrl,
      isPlusVip: isVip,
      currentPlusStyle: isVip ? personData.plus.filter(item => item.purchased == 1)[0] : personData.plus.filter(item => item.purchased == 0)[0]
    });
    
    this.getLevelOpenStatus();
  },
  methods: {
    //获取配置的开关
    getLevelOpenStatus(){
      wxService.get(`/merchant/brandSwitchSetting/getOpenStatus?businessType=2`).then(res => {
        const { result, data } = res.data
        if (result == 0) {
          console.log(data)
          if(data){
            this.getLevelList();
          }
          else{
            this.setData({
              memberIsOpen : false,
            })
          }
        }
      }).finally(() => {
        wx.hideLoading()
      })
    },
    //获取等级列表
    getLevelList(){
      wxService.post('/merchant/settingLevel/get').then(res => {
        console.log(res)
        if(res){
          let levelList = res.data.data ? res.data.data  : [];
          if (levelList.length == 0){
            this.setData({
              memberIsOpen: false,
            })
          }
          else{
            console.log(this.data)
            let index = this.data.baseUserInfo.member.level ? this.data.baseUserInfo.member.level : 0;
            let filterLevel = levelList.filter(item => item.index == index);
            if (filterLevel.length > 0){
              this.data.levelName = filterLevel[0].name;
              this.setData({
                memberIsOpen: true,
                levelName: this.data.levelName,
              })
            }
            else{
              //未找到等级对应数据 则认为等级被删除了或者等级出现错误数据
              this.setData({
                memberIsOpen: false,
              })
            }
          }
        }
      })
    },
    toPlusPay(e) {
      const { row }= e.currentTarget.dataset
      let toPlus = typeof(row) == 'string'?  JSON.parse(row) : row
      if(toPlus.type == 2) {
       let pageId = toPlus.url
        wxService.router(`/subPackage/page/pages/subPage/subPage`).search({ pageId })
      }
    },
    _getUserInfo(res = {}) {
      wxService.nextTick(() => {
        this.triggerEvent('getAuth', res);
      })
    },
    _userInfoChange(newVal, oldVal) {
      if (newVal !== oldVal) {
        // console.log(newVal)
        this.setData({
          memberActivateStatus: newVal && newVal.memberActivateStatus || false,
          memberCardNo: newVal && newVal.memberCardNo || '',
          currentMobile: newVal && newVal.member && newVal.member.mobile || '',
        })
      }
    },
    handleToMemberOfOwn() {
      wxService.router(`/pages/memberOfOwn/memberOfOwn`)
    },
    toBonusDetails() {
      wxService.router(`/pages/integralWater/integralWater`)
    },
    toCouponList() {
      wxService.router(`/pages/coupons/coupons`)
    },
    //我的超值卡
    tapToMyValueCardPage(){
      wxService.router(`/subPackage/page/pages/myValueCard/myValueCard`);
    },
    handleTtoActiveMemebr() {
      if (wx.getStorageSync('_baseUserInfo')) {
        wxService.openCard()
      } else {
        this.setData({
          isAuthorization: true
        })
      }
    },
    handleGoWxCard() {
      wxService.openCard()
    }
  },
  detached() {
    this._userInfoChange = null
  }
})