// pages/logistics/logistics.js
const app = getApp()
const wxService = require('../../utils/wxService')
const utils = require('../../utils/util')
const envInfo = require('../../config/index').envInfo

wxService.page({

  /**
   * 页面的初始数据
   */
  data: {
    logisData:[],
    orderId:'',
    orderCode:'',
    orderLogisticsNo: '',
    params: null,
    hasLogisticInfo : false,
    logisticCompanyName: '',
    logisticNo : '',
    status : '',
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let detail = options.params ? JSON.parse(options.params) : null;
    if(detail){
      this.data.logisticCompanyName = detail.logistic.supplierName ? detail.logistic.supplierName : '暂无';
      this.data.logisticNo = detail.logistic.code ? detail.logistic.code : '暂无';
      this.setData({
        detail,
        orderId: detail.id,
        status: detail.status,
        orderCode: detail.logistic.supplierCode,
        orderLogisticsNo: detail.logistic.code,
        logisticCompanyName: this.data.logisticCompanyName,
        logisticNo: this.data.logisticNo,
      },()=>{
        const {orderCode, orderLogisticsNo} = this.data
        this.getLogisticsInfo(orderCode, orderLogisticsNo)
      })
    };

    wx.hideShareMenu()
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
  },
 
  // 获取物流信息
  getLogisticsInfo(code,num){
    wxService.get(`/sale/logistics/getLogisticsDetail?companyCode=${code}&logisticsNo=${num}`).then(res => {
      if (!res) return false
      const { result, data } = res.data
      if (result == 0) {
        if (data){
          data.list = data.list ? data.list : [];
          for (var i in data.list) {
            if (data.list[i].datetime) {
              data.list[i].date = data.list[i].datetime.substring(0, 10)
              data.list[i].time = data.list[i].datetime.substring(11, 20);
            }
          }
          this.setData({
            logisData: data,
            hasLogisticInfo : true
          })
        }
        else{
          this.setData({
            hasLogisticInfo : false
          })
        }
      }
    }).finally(() => {
    })
  },

  copy(e) {
    wx.setClipboardData({
      //准备复制的数据
      data: e.currentTarget.dataset.content,
      success: function (res) {
        wx.showToast({
          title: '复制成功',
          icon: 'none'
        });
      }
    });
  },


  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

 
})