// pages/memberRules.js
const app = getApp()
const wxService = require('../../utils/wxService')
const utils = require('../../utils/util')
const envInfo = require('../../config/index').envInfo

wxService.page({
  /**
   * 页面的初始数据
   */
  data: {
    ruleImg:'',
    type:''
  },

  onLoad(options) {
    const { type } = options
    this.data.type = type;
    this.setData({
      type: this.data.type
    });

    this.getRule(type)
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    
  },

  //获取规则
  getRule(TYPE){
    wxService.get(`/merchant/brandRuleDescSet/get?type=${TYPE}&brandId=${app.globalData.brandId}`).then(res => {
      if(res){
        let obj = res.data.data ? res.data.data : null;
        if(obj){
          this.data.ruleImg = obj.content ? obj.content : '';
          wx.setNavigationBarTitle({
            title: obj.title
          });
          this.setData({
            ruleImg: this.data.ruleImg
          })
        }
        else{
          wx.setNavigationBarTitle({
            title: '未配置规则'
          });
        }
      }
    });
  }

})