// pages/refundDetail/refundDetail.js
const app = getApp()
const wxService = require('../../utils/wxService')
const utils = require('../../utils/util')
const envInfo = require('../../config/index').envInfo

wxService.page({

  /**
   * 页面的初始数据
   */
  data: {
    showApplyRefundModal: false,
    id: '',
    refundDetail: null,
    refundId : null,
    baseImgUrl: app.globalData.imageUrl,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.data.id = options.id;
    wx.hideShareMenu()
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    const { id } = this.options
    if (id) {
      this.setData({
        id
      }, () => {
        this.getRfDetail(id)
      })
    }
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
    this.getRfDetail(this.data.id);
    setTimeout(() => {
      wx.stopPullDownRefresh();
    }, 500);
  },
  
  handelRevokeRefund() {
    const { id } = this.data
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    // const params = {id}
    wxService.post(`/sale/refund/buyer/cancel?id=${id}`).then(res => {
      if (res) {
        const { result, data } = res.data
        if (result == 0) {
          wx.hideLoading()
          wx.showToast({
            title: '撤销退款成功',
            icon: 'none'
          });
          
          setTimeout(() => {
            wx.navigateBack({
              delta : 1
            });
          },200)
        }
      }
    })
  },
  //填写物流信息之后回调
  onDeliveryOk(){
    this.getRfDetail(this.data.id);
  },
  //获取退单详情
  getRfDetail(id) {
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wxService.post(`/sale/refund/buyer/${id}`).then(res => {
      if (res) {
        let { result, data } = res.data
        if (result == 0) {
          wx.hideLoading();
          data = data ? data : null;
          if (data){
            let skuList = data.skuList, tradeVOSku = data.tradeVO.skuVOList;
            skuList.forEach(item => {
              let filter = tradeVOSku.filter(c => c.skuId == item.skuId);
              if(filter.length > 0){
                item.skuImgUrl = filter[0].skuImgUrl;
                item.productName = filter[0].productName;
                item.skuSpec = filter[0].skuSpec;
                item.price = filter[0].price;
                item.count = filter[0].count;
              }
            });
            console.log(skuList)
            this.setData({
              refundDetail: data
            })
          }
          
        }
      }
    })
  },
  //复制
  copy(e) {
    wx.setClipboardData({
      //准备复制的数据
      data: e.currentTarget.dataset.content,
      success: function (res) {
        wx.showToast({
          title: '复制成功',
          icon: 'none'
        });
      }
    });
  },

  //填写物流信息
  tapWriteLogis() {
    this.setData({
      showApplyRefundModal: true,
      refundId : this.data.id
    })
  }
})