// pages/order/order.js
const wxService = require('../../utils/wxService')
wxService.page({
  /**
   * 页面的初始数据
   */
  data: {
    remark: '',
    inputNum: 0,
    limitNum: 200
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    wx.hideShareMenu();
    let orderRemark = wx.getStorageSync('orderRemark');
    this.setData({
      remark: orderRemark,
    });
  },

  //输入时
  onInput(e) {
    let value = e.detail.value;
    if (!value) {
      this.data.inputNum = 0;
    }
    else {
      this.data.inputNum = value.length;
    }

    if (this.data.inputNum > this.data.limitNum) {
      wx.showToast({
        title: '最多输入' + this.data.limitNum + '个字',
        icon: 'none'
      });

      value = value.substring(0, this.data.limitNum);
      this.data.inputNum = this.data.limitNum;
    }

    this.setData({
      remark: value,
      inputNum: this.data.inputNum
    });
  },
  //输入完成按钮点击事件
  onTapInputOk() {
    wx.setStorageSync('orderRemark', this.data.remark);
    wx.navigateBack({
      delta: 1
    });

  },
 

 


})