// subPackage/component/tabBar/tabBar.js

var app = getApp()
const wxService = require('../../../utils/wxService')
const utils = require('../../../utils/util')
const utilLink = require('../../../utils/currentLinkRouter')
const envInfo = require('../../../config/index').envInfo

Component({
  /**
   * 组件的属性列表
   */
  properties: {
    index : {
      type : Number,
      value : 0
    }
  },

  attached(){
    this.data.tabBar.forEach(item => {
      item.isActive = false;
    });

    this.data.tabBar[this.data.index].isActive = true;
    this.setData({
      tabBar: this.data.tabBar
    });
  },

  /**
   * 组件的初始数据
   */
  data: {
    tabBar : [
      { 
        activeUrl: 'https://img3.bigaka.com/prd/3001/202003/20200331/300125f7a40f-8d9b-4ca3-ac8d-dcfe3607abf3.png', 
        pageUrl: '/shoppingGuid/page/pages/college/college',
        defaultUrl: 'https://img3.bigaka.com/prd/3001/202003/20200331/3001744bdc3f-5bc1-4178-825b-8b39a4fe2bc3.png',
        isActive : false
      },
      {
        activeUrl: 'https://img3.bigaka.com/prd/3001/202003/20200331/3001bb29226a-4faf-4ed9-94da-d5036b17a9fe.png',
        pageUrl: '/shoppingGuid/page/pages/qrcode/qrcode',
        defaultUrl: 'https://img3.bigaka.com/prd/3001/202003/20200331/3001a0e67d2d-bf2c-405a-b0ca-6738ab9f42d7.png',
        isActive: false
      },
      {
        activeUrl: 'https://img3.bigaka.com/prd/3001/202003/20200331/30010a0c94b2-4b51-4e92-a4d8-9f5a07f159e8.png',
        pageUrl: '/shoppingGuid/page/pages/home/home',
        defaultUrl: 'https://img3.bigaka.com/prd/3001/202003/20200331/3001025b9273-e1c1-42f4-a670-77b89f0a4cf4.png',
        isActive: true
      },
      {
        activeUrl: 'https://img3.bigaka.com/prd/3001/202003/20200331/3001598b6ce5-0e82-42e8-a416-8cd304cf7a71.png',
        pageUrl: '/shoppingGuid/page/pages/welfare/welfare',
        defaultUrl: 'https://img3.bigaka.com/prd/3001/202003/20200331/3001d3b53929-7bd9-4fc5-9572-5c2b4af8bff4.png',
        isActive: false
      },
      {
        activeUrl: 'https://img3.bigaka.com/prd/3001/202003/20200331/30016b9d9500-f529-4c05-be15-907ca6fe19e5.png',
        pageUrl: '/shoppingGuid/page/pages/achievement/achievement',
        defaultUrl: 'https://img3.bigaka.com/prd/3001/202003/20200331/30018848b942-1c9e-448f-8f65-102114987b41.png',
        isActive: false
      },
    ]
  },

  /**
   * 组件的方法列表
   */
  methods: {
    //点击
    onTapToPage(e){
      let item = e.currentTarget.dataset.item;
      let index = e.currentTarget.dataset.index;
      //如果点击是本页面，则不进行任何跳转
      if(this.data.index == index){
        return ;
      }
      wx.redirectTo({
        url: item.pageUrl,
      });
    }
  }
})
