// shoppingGuid/page/pages/home/home.js
const wxService = require('../../../../utils/wxService')
const utils = require('../../../../utils/util')
import { Integer } from '../../../../utils/integerDigitalConvertion'
const app = getApp();

const discountBg = 'https://img3.bigaka.com/prd/3001/202003/20200331/3001108068c0-09c6-4d60-a59c-3f27ce8dcf58.png';
const dingeBg = 'https://img3.bigaka.com/prd/3001/202003/20200331/300196a210e9-7c79-44ac-aab3-6df482e8ba7c.png';
const diyongBg = 'https://img3.bigaka.com/prd/3001/202003/20200331/3001aba52f3a-cfb0-4da2-9f7b-f2c147c34ddd.png';

const defaultGoodsImg = 'https://img3.bigaka.com/prd/3001/202003/20200331/30019aa78220-546f-41e0-8075-c2feb69e10b8.jpg';

wxService.page({

  /**
   * 页面的初始数据
   */
  data: {
    navBar: [{ name: '招募榜', type: 1, isActive: true }, { name: '门店榜单', type: 2, isActive: false }],
    current : 1,
    staff : [],
    store : [],
    rankList:[],
    storeList:[],
    defaultAvatar: 'https://img3.bigaka.com/prd/3001/202003/20200331/30018452a3be-b2da-4676-89ca-ebdc75a721a6.png',
    loadingText : '数据加载中...',
    coupon : {
      couponTypeArr: [
        { name: '打折券', type: 2, active: true }, 
        { name: '定额券', type: 3, active: false }, 
        { name: '抵用券', type: 1, active: false }
      ],
      currentCouponType : 2,
      couponList : []
    },
    goods : {
      goodsTypeArr: [
        { name: '最新', type: 'new', active: true },
        { name: '最热🔥', type: 'hot', active: false },
        { name: '推荐👍', type: 'recommend', active: false }
      ],
      currentGoodsType: 'new',
      goodsList: []
    },
    shareModel : {
      title : '',
      path : '',
      imageUrl : ''
    },
    showModal : false,
    saleTaskList : [],
    saleTaskIndex : 0,
  },
  
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    wx.hideShareMenu();
    console.log('guidBaseInfo----', wx.getStorageSync('guidBaseInfo'))
    this.getCouponList();
    // this.getGoodsList();
    this.getSaleTaskList();
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.getRecruitRanking()  // 招募榜
  },
  //销售任务选择改变
  bindSaleTaskChange(e){
    let index = e.detail.value;
    this.data.saleTaskIndex = index;
    this.setData({
      saleTaskIndex : this.data.saleTaskIndex ,
    });
    
    let tempObj = this.data.saleTaskList[this.data.saleTaskIndex];
    let products = tempObj.product ? JSON.parse(tempObj.product) : [];
    if(products.length > 0){
      let ids = products.map(item => {
        return item.id;
      });

      this.getProductsByProductsIds(ids);
    }

  },
  //获取销售任务列表
  getSaleTaskList(){
    wxService.post(`/marketing/shoppingguide/task/page?pageSize=100000&pageNo=1`,{
      brandId: app.globalData.brandId,
      type: 1
    }).then(res => {
      if(res){
        let list = res.data.data.content ? res.data.data.content : [];
        let tempArr = [];
        list.forEach(item => {
          tempArr.push(item.task);
        });
        this.data.saleTaskList = tempArr;
        this.setData({
          saleTaskList : this.data.saleTaskList,
          saleTaskIndex : 0
        });

        if(tempArr.length > 0){
          let tempObj = tempArr[0];
          let products = tempObj.product ? JSON.parse(tempObj.product) : [];
          if(products.length > 0){
            let ids = products.map(item => {
              return item.id;
            });

            this.getProductsByProductsIds(ids);
          }
        }
      }
    });
  },
  //根据商品ids获取商品信息
  getProductsByProductsIds(proIds){
    wx.showLoading({
      title: '获取商品信息中..',
    });
    wxService.post(`/sale/product/listPage?pageNo=1&pageSize=10000`,{
      productIds : proIds,
      showListUrls : true,
    }).then(res => {
      if(res){
        let list = res.data.data.content ? res.data.data.content : [];
        this.data.goods.goodsList = list;
        list.forEach(item => {
          item.price = parseFloat(item.minSalePrice/10/10).toFixed(2);
          item.listUrls = item.listUrls ? item.listUrls : [];
          if(!this.isVideoUrl(item.indexUrl)){
            item.productImgUrl = item.indexUrl ? item.indexUrl :defaultGoodsImg;
          }
          else{
            item.indexUrl = utils.getFirstImgUrl(item.listUrls);
            item.productImgUrl = item.indexUrl ? item.indexUrl :defaultGoodsImg;
          }
        });

        this.setData({
          goods : this.data.goods
        });
      }
    })
  },
  //获取数组中第一个图片格式的url
  isVideoUrl(url){
    if(url){
      let lastIndexOfPoint = url.lastIndexOf('.');
      let extd = url.substring(lastIndexOfPoint).toUpperCase();
      if(extd != '.MP4' && extd != '.MP3' && extd != ".MOV"){
          return false;
      }
      else{
        return true;
      }
    }

    return false;
  },
  //跳转到商品详情
  onTapToGoodsDetail(e){
    let item = e.currentTarget.dataset.item;
    let productId = item.productId;
    wx.navigateTo({
      url: '/pages/productDetail/productDetail?id=' + productId,
    });
  },
  //打开摄像头 扫码
  onTapScanQrcode(){
    if (!this.data.guiderCanScanQrcode){
      wx.showToast({
        title: '对不起，您无该权限!',
        icon : 'none'
      });
      return ;
    }
    wx.scanCode({
      success : res => {
        let result = res.result;
        if(result){
          let arr = result.split('_');
          if(arr.length == 1){
            //处理扫码优惠券的时候
            wx.navigateTo({
              url: '/shoppingGuid/page/pages/couponWriteOff/couponWriteOff?id=' + result,
            });
          }
          else{
            //处理带类型参数的
            let id = arr[0] , type = arr[1];
            //1 自提订单确认收货详情
            if(type == 1){
              wx.navigateTo({
                url: '/subPackageA/page/pages/deliveryCode/deliveryCode?id=' + id,
              });
            }
          }
        }
      },
      fail : err => {
        console.log('扫码失败结果是--',err)
      },
    });
  },
  //获取排行榜
  getRecruitRanking() {
    wx.showLoading({
      title: '加载中'
    });

    wxService.post('/marketing/shoppingguide/recruitRanking').then(res => {
      if (res) {
        const { result, data } = res.data;
        if (result == 0) {
          wx.hideLoading()
          let list = data ? data : [];
          if(list.length == 0){
            this.data.loadingText = '暂无榜单信息~';
          }

          list.map(item => {
            item.member.qiyeInfo = item.member.qiyeInfo ? item.member.qiyeInfo : null;
            if (!item.member.qiyeInfo){
              item.member.qiyeInfo = {
                name : '暂无名称'
              }
            }
          });

          this.setData({
            rankList: list,
            loadingText : this.data.loadingText
          });
        }
      }
    });
  },
  // 门店榜
  getStoreRanking() {
    wx.showLoading({title: '加载中'});
    this.setData({loadingText : '数据加载中...'});
    wxService.post('/marketing/shoppingguide/storeRanking').then(res => {
      if (res) {
        const { result, data } = res.data
        if (result == 0) {
          wx.hideLoading();
          if (!data){
            this.data.loadingText = '暂无榜单信息~';
          }
          
          this.setData({
            storeList: data || [],
            loadingText : this.data.loadingText
          })
        }
      }
    });
  },
  // 点击事件
  onTopBarTap(e){
    let index = e.currentTarget.dataset.index,
      item = e.currentTarget.dataset.item;
    this.data.navBar.forEach(nav => {
      nav.isActive = false;
    });

    this.data.navBar[index].isActive = true;
    this.data.current = this.data.navBar[index].type;
    
    this.setData({
      navBar: this.data.navBar,
      current: this.data.current
    },()=>{
      const { current } = this.data
      current == 1? this.getRecruitRanking() : this.getStoreRanking()
    });
  },
  //跳转到任务中心
  onTapToTaskCenter(){
    wx.navigateTo({
      url: '/shoppingGuid/page/pages/kpi/kpi',
    })
  },
  //跳转到优惠券列表
  onTapToCouponList(){
    wx.navigateTo({
      url: '/shoppingGuid/page/pages/moreCoupons/moreCoupons?type=' + this.data.coupon.currentCouponType,
    });
  },
  //优惠券tab点击
  onTapChangeCouponType(e){
    let index = e.currentTarget.dataset.index;
    this.data.coupon.couponTypeArr.map(item => {
      item.active = false;
    });

    this.data.coupon.couponTypeArr[index].active = true;
    this.data.coupon.currentCouponType = this.data.coupon.couponTypeArr[index].type;
    this.data.coupon.couponList = [];

    this.getCouponList();
    this.setData({
      coupon: this.data.coupon
    });

  },
  //获取优惠券列表
  getCouponList(){
    wx.showLoading({
      title: '加载中..',
    });
    let type = this.data.coupon.currentCouponType;
    wxService.post(`/marketing/shoppingguide/coupon/page4c?pageSize=3&pageNo=1`,{
      couponName : null,
      type: type,
    }).then(res => {
      if(res){
        let list = res.data.data.content ? res.data.data.content : [];
        list.forEach(item => {
          item.price = parseFloat(item.couponSetting.faceAmount / 100).toFixed(2);
          item.couponType = item.couponSetting.type;
          item.typeText = item.couponSetting.typeDesc;
          item.couponBg = item.couponType == 1 ? diyongBg : (item.couponType == 2 ? discountBg : dingeBg);   
        });

        this.data.coupon.couponList = list;
        this.setData({
          coupon: this.data.coupon,
        });
      }
    });
  },
  //展示优惠券二维码
  onTapShowQrcode(e) {
    let item = e.currentTarget.dataset.item;
    wx.setStorageSync('_guidCouponInfo', item);
    wx.navigateTo({
      url: '/shoppingGuid/page/pages/couponQrcode/couponQrcode',
    });
  },
  //定向发送优惠券
  onTapToSendConpon(e) {
    let item = e.currentTarget.dataset.item;
    let id = item.id;
    let content = {
      title: item.title,
      id: id,
      url: 'https://img3.bigaka.com/prd/3001/202003/20200331/3001649f2f08-3b4e-4b5b-97c1-30cdf646651c.png'
    }
    let tentacleInfo = {
      content: JSON.stringify(content),
      contentId: item.id,
      contentType: app.globalData.contants.SHARE_TYPE.STAFF_RECOMMAND, //内容类型 STAFF_RECOMMAND
      title: item.title, //标题
      type: 3// 1:门店,2:员工(暂时不做),3:会员,4:第三方外部渠道,5:智能营销
    }

    wxService.getTentacleContent(tentacleInfo).then(res => {
      if (res && res.id) {
        let tentacleId = res.id;
        let inner_id = Integer.digit(item.id, 10, 64);
        let inner_tentacleId = Integer.digit(tentacleId, 10, 64);
        var path = 'subPackage/page/pages/scanCoupon/scanCoupon' + '?i=' + inner_id + '&t=' + inner_tentacleId;
        this.data.shareModel.title = item.title;
        this.data.shareModel.imageUrl = 'https://img3.bigaka.com/prd/3001/202003/20200331/3001649f2f08-3b4e-4b5b-97c1-30cdf646651c.png';
        this.data.shareModel.path = path;
        this.setData({
          shareModel: this.data.shareModel,
          showModal: true
        });
      }
    });
  },
  //关闭模态框
  onTapCancelShare() {
    this.setData({
      showModal: false
    });
  },
  //群发
  onTapToSendByGroup(e) {
    let item = e.currentTarget.dataset.item;
    let id = item.id;
    let content = {
      title: item.title,
      id: item.id,
      url: 'https://img3.bigaka.com/prd/3001/202003/20200331/3001649f2f08-3b4e-4b5b-97c1-30cdf646651c.png'
    }

    let tentacleInfo = {
      content: JSON.stringify(content),
      contentId: item.id,
      contentType: app.globalData.contants.SHARE_TYPE.STAFF_RECOMMAND, //内容类型 STAFF_RECOMMAND
      title: item.title, //标题
      type: 3// 1:门店,2:员工(暂时不做),3:会员,4:第三方外部渠道,5:智能营销
    }

    wxService.getTentacleContent(tentacleInfo).then(res => {
      if (res && res.id) {
        let tentacleId = res.id;
        let inner_id = Integer.digit(item.id, 10, 64);
        let inner_tentacleId = Integer.digit(tentacleId, 10, 64);
        var path = 'subPackage/page/pages/scanCoupon/scanCoupon' + '?i=' + inner_id + '&t=' + inner_tentacleId;
        //打开企业微信通讯录选择会员
        wx.qy.shareToExternalContact({
          appid: app.globalData.appId,//小程序的appid
          title: item.title, //小程序消息的title
          imgUrl: 'https://img3.bigaka.com/prd/3001/202003/20200331/3001649f2f08-3b4e-4b5b-97c1-30cdf646651c.png',//小程序消息的封面图
          page: path, //小程序消息打开后的路径
          success: function (r) {
            wx.showToast({
              title: '发送成功!'
            });
          },
          fail: function (err) {
          }
        });
      }
    });
  },

  //跳转到更多商品列表
  onTapToMoreProducts(){
    wx.navigateTo({
      url: '/shoppingGuid/page/pages/moreProducts/moreProducts?type=' + this.data.goods.currentGoodsType,
    });
  },

  //定向发送
  //定向转发商品给用户 分享功能
  onTapToShare(e) {
    let item = e.currentTarget.dataset.item;
    // 生成触点对象
    let content = {
      title: item.productName,
      id: item.productId,
      url: item.productImgUrl
    }
    let tentacleInfo = {
      content: JSON.stringify(content),
      contentId: item.productId,
      contentType: app.globalData.contants.SHARE_TYPE.STAFF_RECOMMAND, //内容类型 
      title: item.productName, //标题
      type: 3// 1:门店,2:员工(暂时不做),3:会员,4:第三方外部渠道,5:智能营销
    }

    wxService.getTentacleContent(tentacleInfo).then(res => {
      if (res && res.id) {
        let tentacleId = res.id;
        let inner_id = Integer.digit(item.productId, 10, 64);
        let inner_tentacleId = Integer.digit(tentacleId, 10, 64);
        var path = 'pages/productDetail/productDetail' + '?i=' + inner_id + '&t=' + inner_tentacleId;
        this.data.shareModel.title = item.productName;
        this.data.shareModel.imageUrl = item.productImgUrl;
        this.data.shareModel.path = path;

        this.setData({
          shareModel: this.data.shareModel,
          showModal: true,
        });
      }
    });
  },

  //立即群发商品给用户
  onTapToRecommandProduct(e) {
    let item = e.currentTarget.dataset.item;
    // 生成触点对象
    let content = {
      title: item.productName,
      id: item.productId,
      url: item.productImgUrl
    }
    let tentacleInfo = {
      content: JSON.stringify(content),
      contentId: item.productId,
      contentType: app.globalData.contants.SHARE_TYPE.STAFF_RECOMMAND, //内容类型 
      title: item.productName, //标题
      type: 3// 1:门店,2:员工(暂时不做),3:会员,4:第三方外部渠道,5:智能营销
    }

    wxService.getTentacleContent(tentacleInfo).then(res => {
      if (res && res.id) {
        let tentacleId = res.id;
        let inner_id = Integer.digit(item.productId, 10, 64);
        let inner_tentacleId = Integer.digit(tentacleId, 10, 64);
        var path = 'pages/productDetail/productDetail' + '?i=' + inner_id + '&t=' + inner_tentacleId;
        //打开企业微信通讯录选择会员
        wx.qy.shareToExternalContact({
          appid: app.globalData.appId,//小程序的appid
          title: item.productName, //小程序消息的title
          imgUrl: item.productImgUrl,//小程序消息的封面图
          page: path, //小程序消息打开后的路径
          success: function (res) {
            wx.showToast({
              title: '推荐成功！'
            });
          },
          fail: function (err) {
            console.log('error---------------', err);
          }
        });
      }
    });

  },

  // 回到商城
  onTapToMall(){
    wx.navigateTo({
      url: '/pages/userCenter/userCenter',
    });
  },
  //跳转到会员
  onTapToMember(){
    wx.navigateTo({
      url: '/shoppingGuid/page/pages/myMemberList/myMemberList',
    });
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function (res) {
    console.log(res)
    console.log(this.data.shareModel)
    if (res.from == 'button') {
      return {
        title: this.data.shareModel.title,
        path: this.data.shareModel.path,
        imageUrl: this.data.shareModel.imageUrl
      }
    }
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
    this.getCouponList();
    this.getSaleTaskList();
    if (this.data.current == 1){
      this.getRecruitRanking();
    }
    else if(this.data.current == 2){
      this.getStoreRanking();
    }

    setTimeout(() => {
      wx.stopPullDownRefresh();
    },3000);
    
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },
})