// shoppingGuid/page/pages/moreProducts/moreProducts.js
const wxService = require('../../../../utils/wxService')
const utils = require('../../../../utils/util')
import { Integer } from '../../../../utils/integerDigitalConvertion'
let defaultUrl = 'https://img3.bigaka.com/prd/3001/202003/20200331/30019aa78220-546f-41e0-8075-c2feb69e10b8.jpg';
const defaultGoodsImg = 'https://img3.bigaka.com/prd/3001/202003/20200331/30019aa78220-546f-41e0-8075-c2feb69e10b8.jpg';
const app = getApp();
wxService.page({

  /**
   * 页面的初始数据
   */
  data: {
    goods: {
      goodsTypeArr: [
        { name: '最新', type: 'new', active: true },
        { name: '最热🔥', type: 'hot', active: false },
        { name: '推荐👍', type: 'recommend', active: false }
      ],
      currentGoodsType: 'new',
      goodsList: []
    },
    shareModelObj: {
      title: '',
      imageUrl: '',
      path: ''
    },
    recommandProductsNoData : false,
    showShareModel : false,
    saleTaskList : [],
    saleTaskIndex : 0,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    wx.hideShareMenu();
    let type = options.type;
    if (type) {
      this.data.goods.currentGoodsType = type;
      this.data.goods.goodsTypeArr.map(item => {
        item.active = false;
        if (item.type == type) {
          item.active = true;
        }
      });

      this.setData({
        goods: this.data.goods
      });
    }

    //获取优惠券列表
    // this.getGoodsList();
    this.getSaleTaskList();
  },

   //销售任务选择改变
   bindSaleTaskChange(e){
    let index = e.detail.value;
    this.data.saleTaskIndex = index;
    this.setData({
      saleTaskIndex : this.data.saleTaskIndex ,
    });
    
    let tempObj = this.data.saleTaskList[this.data.saleTaskIndex];
    let products = tempObj.product ? JSON.parse(tempObj.product) : [];
    if(products.length > 0){
      let ids = products.map(item => {
        return item.id;
      });

      this.getProductsByProductsIds(ids);
    }

  },
  //获取销售任务列表
  getSaleTaskList(refresh){
    wxService.post(`/marketing/shoppingguide/task/page?pageSize=100000&pageNo=1`,{
      brandId: app.globalData.brandId,
      type: 1
    }).then(res => {
      if(res){
        let list = res.data.data.content ? res.data.data.content : [];
        let tempArr = [];
        list.forEach(item => {
          tempArr.push(item.task);
        });
        // this.data.saleTaskList = tempArr;
        // this.setData({
        //   saleTaskList : this.data.saleTaskList,
        //   saleTaskIndex : 0
        // });

        //这里获取全部的销售任务商品
        let allProIds = [];
        tempArr.forEach(item => {
          let tempObj = item;
          let products = tempObj.product ? JSON.parse(tempObj.product) : [];
          products.forEach(p => {
            allProIds.push(p.id);
          });
        });

        if(allProIds.length > 0){
          this.getProductsByProductsIds(allProIds);
        }
      }

      if(refresh){
        wx.stopPullDownRefresh();
        wx.showToast({
          title: '刷新成功',
        });
      }
    });
  },
  //根据商品ids获取商品信息
  getProductsByProductsIds(proIds){
    wx.showLoading({
      title: '获取商品信息中..',
    });
    wxService.post(`/sale/product/listPage?pageNo=1&pageSize=10000`,{
      productIds : proIds,
      showListUrls : true,
    }).then(res => {
      if(res){
        let list = res.data.data.content ? res.data.data.content : [];
        this.data.goods.goodsList = list;
        list.forEach(item => {
          item.price = parseFloat(item.minSalePrice/10/10).toFixed(2);
          item.listUrls = item.listUrls ? item.listUrls : [];
          if(!utils.isVideo(item.indexUrl)){
            item.productImgUrl = item.indexUrl ? item.indexUrl :defaultGoodsImg;
          }
          else{
            item.indexUrl = utils.getFirstImgUrl(item.listUrls);
            item.productImgUrl = item.indexUrl ? item.indexUrl :defaultGoodsImg;
          }
        });

        this.setData({
          goods : this.data.goods
        });
      }
    })
  },

  //获取数组中第一个图片格式的url
  isVideoUrl(url){
    if(url){
      let lastIndexOfPoint = url.lastIndexOf('.');
      let extd = url.substring(lastIndexOfPoint).toUpperCase();
      if(extd != '.MP4' && extd != '.MP3' && extd != ".MOV"){
          return false;
      }
      else{
        return true;
      }
    }

    return false;
  },
  //跳转到商品详情
  onTapToGoodsDetail(e) {
    let item = e.currentTarget.dataset.item;
    let productId = item.productId;
    wx.navigateTo({
      url: '/pages/productDetail/productDetail?id=' + productId,
    });
  },

  //筛选点击
  onTapChangeGoodsType(e){
    let index = e.currentTarget.dataset.index;
    this.data.goods.goodsTypeArr.map(item => {
      item.active = false;
    });

    this.data.goods.goodsTypeArr[index].active = true;
    this.data.goods.currentGoodsType = this.data.goods.goodsTypeArr[index].type;
    this.getGoodsList();
    this.setData({
      goods: this.data.goods
    });
  },
  //获取商品列表
  getGoodsList(refresh){
    wx.showLoading({
      title: '加载中',
      mask: true
    });
    let order = this.data.goods.currentGoodsType;
    wxService.post(`/merchant/share/productBonus/buyer/findPageOrder?pageNo=1&pageSize=20&order=${order}`, {}).then(res => {
      if (res) {
        const { result, data } = res.data
        if (result == 0) {
          wx.hideLoading()
          let list = data.content ? data.content : [];
          list.forEach(item => {
            item.productImgUrl = item.productImgUrl ?
              item.productImgUrl : 'https://img3.bigaka.com/prd/3001/202003/20200331/3001252b3e12-3d1b-45ec-a266-32bcb848f6b1.jpg';  
          });

          if (list.length == 0) {
            this.data.recommandProductsNoData = true;
          }

          this.data.goods.goodsList = list;
          this.setData({
            goods: this.data.goods,
            recommandProductsNoData: this.data.recommandProductsNoData
          });
        }

        if (refresh) {
          wx.stopPullDownRefresh();
          wx.showToast({
            title: '刷新成功',
            icon: 'none'
          });
        }
      }
    });
  },

  //
  //立即群发商品给用户
  onTapToRecommandProduct(e) {
    let item = e.currentTarget.dataset.item;
    // 生成触点对象
    let content = {
      title: item.productName,
      id: item.productId,
      url: item.productImgUrl
    }
    let tentacleInfo = {
      content: JSON.stringify(content),
      contentId: item.productId,
      contentType: app.globalData.contants.SHARE_TYPE.PRODUCT_DETAIL, //内容类型 
      title: item.productName, //标题
      type: 3// 1:门店,2:员工(暂时不做),3:会员,4:第三方外部渠道,5:智能营销
    }

    wxService.getTentacleContent(tentacleInfo).then(res => {
      if (res && res.id) {
        let tentacleId = res.id;
        let inner_id = Integer.digit(item.productId, 10, 64);
        let inner_tentacleId = Integer.digit(tentacleId, 10, 64);
        var path = 'pages/productDetail/productDetail' + '?i=' + inner_id + '&t=' + inner_tentacleId;
        //打开企业微信通讯录选择会员
        wx.qy.shareToExternalContact({
          appid: app.globalData.appId,//小程序的appid
          title: item.productName, //小程序消息的title
          imgUrl: item.productImgUrl,//小程序消息的封面图
          page: path, //小程序消息打开后的路径
          success: function (res) {
            wx.showToast({
              title: '推荐成功！'
            });
          },
          fail: function (err) {
            console.log('error---------------', err);
          }
        });
      }
    });

  },

  //定向发送
  //定向转发商品给用户 分享功能
  onTapToShare(e) {
    let item = e.currentTarget.dataset.item;
    // 生成触点对象
    let content = {
      title: item.productName,
      id: item.productId,
      url: item.productImgUrl
    }
    let tentacleInfo = {
      content: JSON.stringify(content),
      contentId: item.productId,
      contentType: app.globalData.contants.SHARE_TYPE.PRODUCT_DETAIL, //内容类型 
      title: item.productName, //标题
      type: 3// 1:门店,2:员工(暂时不做),3:会员,4:第三方外部渠道,5:智能营销
    }

    wxService.getTentacleContent(tentacleInfo).then(res => {
      if (res && res.id) {
        let tentacleId = res.id;
        let inner_id = Integer.digit(item.productId, 10, 64);
        let inner_tentacleId = Integer.digit(tentacleId, 10, 64);
        var path = 'pages/productDetail/productDetail' + '?i=' + inner_id + '&t=' + inner_tentacleId;
        this.data.shareModelObj.title = item.productName;
        this.data.shareModelObj.imageUrl = item.productImgUrl;
        this.data.shareModelObj.path = path;

        this.setData({
          shareModelObj: this.data.shareModelObj,
          showShareModel: true,
        });

      }
    });
  },

  //取消分享
  onTapCancelShare(){
    this.setData({
      showShareModel: false,
    });
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
    this.data.goods.goodsList = [];
    this.getSaleTaskList(true);
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },
  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function (res) {
    if (res.from == 'button') {
      return {
        title: this.data.shareModelObj.title,
        path: this.data.shareModelObj.path,
        imageUrl: this.data.shareModelObj.imageUrl
      }
    }
  }
})