// shoppingGuid/page/pages/userList/userList.js
const app = getApp()
const wxService = require('../../../../utils/wxService')
import { Integer } from '../../../../utils/integerDigitalConvertion'
wxService.page({
  /**
   * 页面的初始数据
   */
  data: {
    list : [],
    name : '',
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    wx.hideShareMenu();
    let tagId = Integer.digit(options.id,64,10),
      groupId = Integer.digit(options.groupId, 64, 10),
      type = options.type,
      name = options.name;
    
    this.setData({
      name : name
    });
    this.getMemberList(tagId, groupId, type);

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
  },
  // 获取标签下会员
  getMemberList(tagId, groupId, type){
    wx.showLoading({
      title: '加载中'
    });
    let query = {
      tagId,
      groupId,
      type
    }
    let defaultImg = 'https://img3.bigaka.com/prd/3001/202003/20200331/3001e669048a-b2e6-452f-9ae5-f659a56be66e.png';
    wxService.post(`/marketing/shoppingguide/tag/member`, query).then(res => {
      if (res) {
        const { result, data } = res.data
        if (result == 0) {
          wx.hideLoading()
          this.data.list = data ? data : [];
          this.data.list.forEach(item => {
            item.disabled = item.qiyeExternalUserid ? false : true;
            item.logo = item.member ? (item.member.memberWeixin ? (
                item.member.memberWeixin.headimgurl ? item.member.memberWeixin.headimgurl : defaultImg) : defaultImg
            ) : defaultImg
          });
          this.setData({
            list: this.data.list,
          });
        }
      }
    })
  },
  //跳转到会员详情
  onTapToMemberInfo(e){
    let item = e.currentTarget.dataset.item;
    wx.navigateTo({
      url: '/shoppingGuid/page/pages/userInfo/userInfo?id=' + item.id,
    });
  },
  //回访
  onTapRecall(e){
    const currentEnv = wx.getStorageSync('_qyWeChat');
    // wmfen5DwAA5WDE7CBEa_qgIva_cUlAyw 杨辰的外部联系人userid

    if(currentEnv){
      let guidInfo = wx.getStorageSync('guidBaseInfo'),
        guidQiyeUserId = guidInfo.member.qiyeInfo.userid;

      let qiyeExternalUserid = e.currentTarget.dataset.item.qiyeExternalUserid;
      if (!qiyeExternalUserid) {
        wx.showToast({
          title: '该会员还不是您的好友，请先加好友！',
          icon: 'none'
        });
        return;
      }

      wx.qy.openEnterpriseChat({
        userIds: guidQiyeUserId,    //参与会话的企业成员列表，格式为userid1;userid2;...，用分号隔开。
        externalUserIds: qiyeExternalUserid, // 参与会话的外部联系人列表，格式为userId1;userId2;…，用分号隔开。
        groupName: '',  // 必填，会话名称。单聊时该参数传入空字符串""即可。
        success: function (res) {
        },
        fail: function (res) {
          // 失败处理
          wx.showToast({
            title: '创建会话失败，请稍后再试！',
            icon: 'none'
          });
        }
      });

    }else{
      wx.showToast({
        title: '请在企业微信中使用',
        icon : 'none'
      });
    }
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})