// shoppingGuid/page/pages/welfare/welfare.js
const wxService = require('../../../../utils/wxService')
const utils = require('../../../../utils/util')
import { Integer } from '../../../../utils/integerDigitalConvertion'
var app = getApp()

const discountBg = 'https://img3.bigaka.com/prd/3001/202003/20200331/3001108068c0-09c6-4d60-a59c-3f27ce8dcf58.png';
const dingeBg = 'https://img3.bigaka.com/prd/3001/202003/20200331/300196a210e9-7c79-44ac-aab3-6df482e8ba7c.png';
const diyongBg = 'https://img3.bigaka.com/prd/3001/202003/20200331/3001aba52f3a-cfb0-4da2-9f7b-f2c147c34ddd.png';
const defaultGoodsImg = 'https://img3.bigaka.com/prd/3001/202003/20200331/30019aa78220-546f-41e0-8075-c2feb69e10b8.jpg';

wxService.page({
  /**
   * 页面的初始数据
   */
  data: {
    coupon : {
      couponTypeArr: [
        { name: '打折券', type: 2, active: true },
        { name: '定额券', type: 3, active: false },
        { name: '抵用券', type: 1, active: false }
      ],
      currentCouponType: 2,
      couponList : []
    },
    goods : {
      goodsTypeArr: [
        { name: '最新', type: 'new', active: true },
        { name: '最热🔥', type: 'hot', active: false },
        { name: '推荐👍', type: 'recommend', active: false }
      ],
      currentGoodsType: 'new',
      goodsList: []
    },
    
    showModal : false,
    shareModel : {
      title : '',
      path : '',
      imageUrl : ''
    },
    saleTaskList : [],
    saleTaskIndex : 0,

  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.getCouponList();
    // this.getGoodsList();
    wx.hideShareMenu();
    this.getSaleTaskList();
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.setData({
      showModal : false,
    })
  },

  //销售任务选择改变
  bindSaleTaskChange(e){
    let index = e.detail.value;
    this.data.saleTaskIndex = index;
    this.setData({
      saleTaskIndex : this.data.saleTaskIndex ,
    });
    
    let tempObj = this.data.saleTaskList[this.data.saleTaskIndex];
    let products = tempObj.product ? JSON.parse(tempObj.product) : [];
    if(products.length > 0){
      let ids = products.map(item => {
        return item.id;
      });

      this.getProductsByProductsIds(ids);
    }

  },
  //获取销售任务列表
  getSaleTaskList(){
    wxService.post(`/marketing/shoppingguide/task/page?pageSize=100000&pageNo=1`,{
      brandId: app.globalData.brandId,
      type: 1
    }).then(res => {
      if(res){
        let list = res.data.data.content ? res.data.data.content : [];
        let tempArr = [];
        list.forEach(item => {
          tempArr.push(item.task);
        });
        this.data.saleTaskList = tempArr;
        this.setData({
          saleTaskList : this.data.saleTaskList,
          saleTaskIndex : 0
        });

        if(tempArr.length > 0){
          let tempObj = tempArr[0];
          let products = tempObj.product ? JSON.parse(tempObj.product) : [];
          if(products.length > 0){
            let ids = products.map(item => {
              return item.id;
            });

            this.getProductsByProductsIds(ids);
          }
        }
      }
    });
  },
  //根据商品ids获取商品信息
  getProductsByProductsIds(proIds){
    wx.showLoading({
      title: '获取商品信息中..',
    });
    wxService.post(`/sale/product/listPage?pageNo=1&pageSize=10000`,{
      productIds : proIds,
      showListUrls : true,
    }).then(res => {
      if(res){
        let list = res.data.data.content ? res.data.data.content : [];
        this.data.goods.goodsList = list;
        list.forEach(item => {
          item.price = parseFloat(item.minSalePrice/10/10).toFixed(2);
          item.listUrls = item.listUrls ? item.listUrls : [];
          if(!utils.isVideo(item.indexUrl)){
            item.productImgUrl = item.indexUrl ? item.indexUrl :defaultGoodsImg;
          }
          else{
            item.indexUrl = utils.getFirstImgUrl(item.listUrls);
            item.productImgUrl = item.indexUrl ? item.indexUrl :defaultGoodsImg;
          }
        });

        this.setData({
          goods : this.data.goods
        });
      }
    })
  },

  //跳转到更多商品列表
  onTapToMoreProducts() {
    wx.navigateTo({
      url: '/shoppingGuid/page/pages/moreProducts/moreProducts?type=' + this.data.goods.currentGoodsType,
    });
  },

  //跳转到优惠券列表
  onTapToCouponList() {
    wx.navigateTo({
      url: '/shoppingGuid/page/pages/moreCoupons/moreCoupons?type=' + this.data.coupon.currentCouponType,
    });
  },

  //导购发布种草内容
  onTapToReleaseContent(){
    wx.navigateTo({
      url: '/shoppingGuid/page/pages/releaseContent/releaseContent',
    });
  },

  //点击事件
  //分类点击
  onTapChangeCouponType(e) {
    let index = e.currentTarget.dataset.index;
    this.data.coupon.couponTypeArr.map(item => {
      item.active = false;
    });

    this.data.coupon.couponTypeArr[index].active = true;
    this.data.coupon.currentCouponType = this.data.coupon.couponTypeArr[index].type;
    this.data.coupon.couponList = [];

    this.getCouponList();
    this.setData({
      coupon: this.data.coupon
    });

  },

  //获取优惠券列表
  getCouponList() {
    wx.showLoading({
      title: '加载中..',
    });
    let type = this.data.coupon.currentCouponType;
    wxService.post(`/marketing/shoppingguide/coupon/page4c?pageSize=3&pageNo=1`, {
      couponName: '',
      type: type
    }).then(res => {
      if (res) {
        let list = res.data.data.content ? res.data.data.content : [];
        list.forEach(item => {
          item.couponType = item.couponSetting.type;
          item.couponBg = item.couponType == 1 ? diyongBg : (item.couponType == 2 ? discountBg : dingeBg);
        });

        this.data.coupon.couponList = list;
        this.setData({
          coupon: this.data.coupon,
        });
      }
    });
  },

  //展示优惠券二维码
  onTapShowQrcode(e) {
    let item = e.currentTarget.dataset.item;
    wx.setStorageSync('_guidCouponInfo', item);
    wx.navigateTo({
      url: '/shoppingGuid/page/pages/couponQrcode/couponQrcode',
    });
  },
  //定向发送优惠券
  onTapToSendConpon(e) {
    let item = e.currentTarget.dataset.item;
    let id = item.id;
    let content = {
      title: item.title,
      id: id,
      url: item.couponBg
    }
    let tentacleInfo = {
      content: JSON.stringify(content),
      contentId: item.id,
      contentType: app.globalData.contants.SHARE_TYPE.PRODUCT_DETAIL, //内容类型 STAFF_RECOMMAND
      title: item.title, //标题
      type: 3// 1:门店,2:员工(暂时不做),3:会员,4:第三方外部渠道,5:智能营销
    }

    wxService.getTentacleContent(tentacleInfo).then(res => {
      if (res && res.id) {
        let tentacleId = res.id;
        let inner_id = Integer.digit(item.id, 10, 64);
        let inner_tentacleId = Integer.digit(tentacleId, 10, 64);
        var path = 'subPackage/page/pages/scanCoupon/scanCoupon' + '?i=' + inner_id + '&t=' + inner_tentacleId;
        this.data.shareModel.title = item.title;
        this.data.shareModel.imageUrl = 'https://img3.bigaka.com/prd/3001/202003/20200331/3001649f2f08-3b4e-4b5b-97c1-30cdf646651c.png';
        this.data.shareModel.path = path;
        this.setData({
          shareModel: this.data.shareModel,
          showModal: true
        });
      }
    });
  },
  //关闭模态框
  onTapCancelShare() {
    this.setData({
      showModal: false
    });
  },

  //群发
  onTapToSendByGroup(e) {
    let item = e.currentTarget.dataset.item;
    let id = item.id;
    let content = {
      title: item.title,
      id: item.id,
      url: item.imageBg
    }

    let tentacleInfo = {
      content: JSON.stringify(content),
      contentId: item.id,
      contentType: app.globalData.contants.SHARE_TYPE.PRODUCT_DETAIL, //内容类型 STAFF_RECOMMAND
      title: item.title, //标题
      type: 3// 1:门店,2:员工(暂时不做),3:会员,4:第三方外部渠道,5:智能营销
    }

    wxService.getTentacleContent(tentacleInfo).then(res => {
      if (res && res.id) {
        let tentacleId = res.id;
        let inner_id = Integer.digit(item.couponId, 10, 64);
        let inner_tentacleId = Integer.digit(tentacleId, 10, 64);
        var path = 'subPackage/page/pages/scanCoupon/scanCoupon' + '?i=' + inner_id + '&t=' + inner_tentacleId;
        //打开企业微信通讯录选择会员
        wx.qy.shareToExternalContact({
          appid: app.globalData.appId,//小程序的appid
          title: item.couponName, //小程序消息的title
          imgUrl: 'https://img3.bigaka.com/prd/3001/202003/20200331/3001649f2f08-3b4e-4b5b-97c1-30cdf646651c.png',//小程序消息的封面图
          page: path, //小程序消息打开后的路径
          success: function (r) {
            wx.showToast({
              title: '发送成功!'
            });
          },
          fail: function (err) {
          }
        });
      }
    });
  },

  //定向发送
  //定向转发商品给用户 分享功能
  onTapToShare(e) {
    let item = e.currentTarget.dataset.item;
    // 生成触点对象
    let content = {
      title: item.productName,
      id: item.productId,
      url: item.productImgUrl
    }
    let tentacleInfo = {
      content: JSON.stringify(content),
      contentId: item.productId,
      contentType: app.globalData.contants.SHARE_TYPE.PRODUCT_DETAIL, //内容类型 
      title: item.productName, //标题
      type: 3// 1:门店,2:员工(暂时不做),3:会员,4:第三方外部渠道,5:智能营销
    }

    wxService.getTentacleContent(tentacleInfo).then(res => {
      if (res && res.id) {
        let tentacleId = res.id;
        let inner_id = Integer.digit(item.productId, 10, 64);
        let inner_tentacleId = Integer.digit(tentacleId, 10, 64);
        var path = 'pages/productDetail/productDetail' + '?i=' + inner_id + '&t=' + inner_tentacleId;
        this.data.shareModel.title = item.productName;
        this.data.shareModel.imageUrl = item.productImgUrl;
        this.data.shareModel.path = path;

        this.setData({
          shareModel: this.data.shareModel,
          showModal: true,
        });
      }
    });
  },

  //立即群发商品给用户
  onTapToRecommandProduct(e) {
    let item = e.currentTarget.dataset.item;
    // 生成触点对象
    let content = {
      title: item.productName,
      id: item.productId,
      url: item.productImgUrl
    }
    let tentacleInfo = {
      content: JSON.stringify(content),
      contentId: item.productId,
      contentType: app.globalData.contants.SHARE_TYPE.PRODUCT_DETAIL, //内容类型 
      title: item.productName, //标题
      type: 3// 1:门店,2:员工(暂时不做),3:会员,4:第三方外部渠道,5:智能营销
    }

    wxService.getTentacleContent(tentacleInfo).then(res => {
      if (res && res.id) {
        let tentacleId = res.id;
        let inner_id = Integer.digit(item.productId, 10, 64);
        let inner_tentacleId = Integer.digit(tentacleId, 10, 64);
        var path = 'pages/productDetail/productDetail' + '?i=' + inner_id + '&t=' + inner_tentacleId;
        //打开企业微信通讯录选择会员
        wx.qy.shareToExternalContact({
          appid: app.globalData.appId,//小程序的appid
          title: item.productName, //小程序消息的title
          imgUrl: item.productImgUrl,//小程序消息的封面图
          page: path, //小程序消息打开后的路径
          success: function (res) {
            wx.showToast({
              title: '推荐成功！'
            });
          },
          fail: function (err) {
            console.log('error---------------', err);
          }
        });
      }
    });

  },
  
  
  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
    console.log('pull done')
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function (res) {
    if (res.from == 'button'){
      return {
        title : this.data.shareModel.title,
        path: this.data.shareModel.path,
        imageUrl: this.data.shareModel.imageUrl
      }
    }
  }
})