// subPackage/page/pages/fun/fun.js
var app = getApp()
const wxService = require('../../../../utils/wxService')

import { Integer } from '../../../../utils/integerDigitalConvertion'
let defaultImg = 'https://img3.bigaka.com/prd/3001/202003/20200331/30019aa78220-546f-41e0-8075-c2feb69e10b8.jpg';

wxService.page({

  /**
   * 页面的初始数据
   */
  data: {
    proData: [],
    pageNo: 1,
    pageSize: 10,
    totalPages: '',
    form: {
      mallCategoryId: '',
      sortType:'',
      order:''
    },
    navTab:[
      {
        name: '推荐',
        type: 'recommend'
      },
      {
        name: '最新',
        type: 'new'
      },
      {
        name: '最热',
        type: 'hot'
      },
      {
        name: '价格',
        type: 'price'
      },
    ],
    priceSort:false,
    currentTab:'recommend',
    proStyle:false,
    tagId :  null,
  },

  /**
  * 生命周期函数--监听页面加载
  */
  onLoad: function (options) {
    let type = options.type;
    //说明是从分类中过来的
    if(!type){
      if (options && options.id) {
        this.setData({
          'form.mallCategoryId': options.id
        })
      }

      this.setData({
        'form.sortType': this.data.currentTab
      })
      this.getProList();
    }
    //说明是从商品标签中来的
    else if (type == 'pTag'){
      this.data.tagId = options.id;
      this.setData({
        tagId: this.data.tagId,
        'form.sortType': this.data.currentTab
      },() => {
        //根据tagid 获取商品列表
        this.getProList();
      });
      
    }
    
    //生成触点
    this.getMemberIdAndGeneratorPoint(options);
  },

  //生成触点
  getMemberIdAndGeneratorPoint(options){
    let memberId = options.memberId;
    if (memberId) {
      let tentacleInfo = {
        content: '商品列表',
        title: '商品列表',
        tentacleId: memberId,
        contentType: app.globalData.contants.SHARE_TYPE.PRODUCT_LIST,
        type: 3// 1:门店,2:员工(暂时不做),3:会员,4:第三方外部渠道,5:智能营销
      };

      this.generatePointObject(tentacleInfo);
    }
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    
  },

  // 切换tab
  switchTab(e){
    this.data.form.order = '';
    this.setData({
      currentTab: e.currentTarget.dataset.type,
      'form.sortType': e.currentTarget.dataset.type
    })
    if (this.data.currentTab == 'price'){
      if (!this.data.priceSort){
        this.setData({
          'form.order': 'desc',
          priceSort: true
        })
      }else{
        this.setData({
          'form.order': 'asc',
          priceSort: false
        })
      }
    }
    this.data.pageNo = 1;
    
    this.getProList();
  },

  //获取商品列表
  getProList(refresh) {
    if(!this.data.tagId){
      this.getProductListByCategoryId(refresh);
    }
    else{
      this.getProductListByTagId(refresh);
    }
  },
  //获取商品列表
  getProductListByCategoryId(refresh){
    wx.showLoading({
      title: '加载中'
    });
    let pageNo = this.data.pageNo,
      pageSize = this.data.pageSize;
    wxService.post(`/sale/product/buyer/listPageByCategoryId?pageNo=${pageNo}&pageSize=${pageSize}`, this.data.form).then(res => {
      const { result, data } = res.data
      if (result == 0 && data.content) {
        wx.hideLoading()
        this.data.proData = this.data.pageNo == 1 ? [...data.content] : [...this.data.proData, ...data.content];
        this.data.proData.forEach(item => {
          item.indexUrl = item.indexUrl ? item.indexUrl : defaultImg;
        });
        this.setData({
          proData: this.data.proData,
          totalPages: data.totalPages,
          totalElements: data.totalElements
        })
      }

      if (refresh) {
        wx.showToast({
          title: '数据已刷新',
        });
        wx.stopPullDownRefresh();
      }

    }).finally(() => {
      wx.hideLoading()
    })
  },

  //找到第一个是图片的主图
  //获取数组中第一个图片格式的url
  getFirstImgUrl(urls){
    let retUrl = '';
    for(let i = 0 ; i < urls.length ; i ++){
        let url = urls[i];
        let lastIndexOfPoint = url.lastIndexOf('.');
        let extd = url.substring(lastIndexOfPoint).toUpperCase();
        if(extd != '.MP4' && extd != '.MP3' && extd != ".MOV"){
            retUrl = url;
            break;
        }
    }
    
    return  retUrl;
  },

  //获取商品列表 通过tagid
  getProductListByTagId(refresh){
    wx.showLoading({
      title: '加载中'
    });
    let pageNo = this.data.pageNo,
      pageSize = this.data.pageSize;
    wxService.post(`/sale/product/listPage?pageSize=${pageSize}&pageNo=${pageNo}`,{
      productName: "",
      showStockData: true,
      categoryIds: [],
      productTagIds : [this.data.tagId],
      productStatus : 2,
      showListUrls : true,
      // sortType : this.data.form.sortType,
      // order : this.data.form.order,
    }).then(res => {
      const { result, data } = res.data
      if (result == 0 && data.content) {
        wx.hideLoading();
        this.data.proData = this.data.pageNo == 1 ? [...data.content] : [...this.data.proData, ...data.content];
        this.data.proData.forEach(item => {
          item.indexUrl = item.indexUrl ? item.indexUrl : 'https://img3.bigaka.com/prd/3001/202003/20200331/30019aa78220-546f-41e0-8075-c2feb69e10b8.jpg';
        });
        this.setData({
          proData: this.data.proData,
          totalPages: data.totalPages,
          totalElements: data.totalElements
        })
      }

      if(refresh){
        wx.showToast({
          title: '数据已刷新',
        });
        wx.stopPullDownRefresh();
      }
    }).finally(() => {
      wx.hideLoading()
    })
  },

  // 切换列表样式
  switchProStyle(){
    this.setData({
      proStyle: !this.data.proStyle
    })
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
    this.data.pageNo = 1;
    this.data.totalPages = 0;
    this.getProList(true);
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    const { pageNo, pageSize, totalPages } = this.data
    if (pageNo < totalPages) {
      this.setData({
        pageNo: pageNo + 1,
      })
      this.getProList()
    }
  },

  /**
 * 用户点击右上角分享
 */
  onShareAppMessage: function (res) {
   
    //修改为参数memberId
    const { memberId, member } = wx.getStorageSync('_baseUserInfo')
    var path = `subPackage/page/pages/categoryPro/categoryPro?id=${this.data.form.mallCategoryId}`;
    if (memberId) {
      let m = Integer.digit(memberId, 10, 64);
      path = `subPackage/page/pages/categoryPro/categoryPro?m=${m}&id=${this.data.form.mallCategoryId}`;
    }
    return {
      title: '我给你分享了一些商品，赶紧去看看吧~',
      path: path
    }
  }
})