const wxService = require('./wxService')
const app = getApp()

function currentLinkRouter(event, _this) {
  const ev = event.currentTarget.dataset;
  let curItemType = ev.item
  const userInfo = wx.getStorageSync('_baseUserInfo')
  // link row
  if (curItemType.link) {
    //处理返回值是空对象时 导致跳转失败
    if (Object.keys(curItemType.link).length > 0){
      let currentClickType = app.globalData.commonFunc.getLink(curItemType.link.type, curItemType)
      if (curItemType.link.type == 1) {
        // 触发父组件更新页面 外部小程序
      } else if (curItemType.link.type == 2) {
        // 触发父组件更新页面
        wxService.nextTick(() => {
          _this.triggerEvent('updatePage', { pageId: currentClickType.url })
        });
      } else if (curItemType.link.type == 3) {
        // 预览
        if (currentClickType.imageUrl.indexOf('http') > -1){
          wx.previewImage({
            current: `${currentClickType.imageUrl}`, // 当前显示图片的http链接
            urls: [`${currentClickType.link.url}`]  // 需要预览的图片http链接列表
          })
        }
        else{
          wx.previewImage({
            current: `${app.globalData.imageUrl}/${currentClickType.imageUrl}`, // 当前显示图片的http链接
            urls: [`${app.globalData.imageUrl}/${currentClickType.link.url}`]  // 需要预览的图片http链接列表
          })
        }
        
      } else if (curItemType.link.type == 4) {
        if( currentClickType === '/pages/userCenter/userCenter') {
          wx.reLaunch({
            url: currentClickType,
          });
          // wxService.router(`${currentClickType}`).replace() // 是首页重定向
        } else {
          wxService.router(`${currentClickType}`)
        }
      } else if (curItemType.link.type == 5) {
        if (currentClickType == 1) {
          wxService.openCard()
        } else if (currentClickType == 2) {
          wxService.openCard()
        }
      } else if (curItemType.link.type == 6) {
        wxService.router(`${currentClickType}`)
      } else if (curItemType.link.type == 7) {
        // 集点详情
        wxService.router(`${currentClickType}`)
      } else if (curItemType.link.type == 8) {
        wxService.router(`/pages/productDetail/productDetail?id=${currentClickType}`)
      } else if (curItemType.link.type == 9) {
        wxService.router(`/subPackage/page/pages/categoryPro/categoryPro?id=${currentClickType}`)
      } else if (curItemType.link.type == 10) {
        wxService.router(`/subPackage/page/pages/categoryPro/categoryPro?id=${currentClickType}&type=pTag`)
      } 
    }
    else{
      let rowObj = typeof (curItemType.row) == "string" ? JSON.parse(curItemType.row) : curItemType.row
      if (!rowObj){
        rowObj = {};
      }
      let currentClickRow = app.globalData.commonFunc.getLinkRow(rowObj.type, rowObj)

      if (rowObj.type == 1) { }
      else if (rowObj.type == 2) { }
      else if (rowObj.type == 3) { }
      else if (rowObj.type == 4) { }
      else if (rowObj.type == 5) { }
      else if (rowObj.type == 6) { }
      else if (rowObj.type == 7) { }
      else if (rowObj.type == 8) {
        // 商品
        wxService.router(`/pages/productDetail/productDetail?id=${currentClickRow}`)
      }
      else if (rowObj.type == 9) {
        // 分类
        wxService.router(`/subPackage/page/pages/categoryPro/categoryPro?id=${currentClickRow}`)
      } else if (rowObj.type == 10) {
        wxService.router(`/subPackage/page/pages/categoryPro/categoryPro?id=${currentClickRow}&type=pTag`)
      } 
    }
  } else if (curItemType.row) {
    let rowObj = typeof(curItemType.row) == "string" ? JSON.parse(curItemType.row) : curItemType.row
    let currentClickRow = app.globalData.commonFunc.getLinkRow(rowObj.type, rowObj)

    if (rowObj.type == 1) { }
    else if (rowObj.type == 2) { }
    else if (rowObj.type == 3) { }
    else if (rowObj.type == 4) { }
    else if (rowObj.type == 5) { }
    else if (rowObj.type == 6) { }
    else if (rowObj.type == 7) { }
    else if (rowObj.type == 8) {
      // 商品
      wxService.router(`/pages/productDetail/productDetail?id=${currentClickRow}`)
    }
    else if (rowObj.type == 9) { 
      // 分类
      wxService.router(`/subPackage/page/pages/categoryPro/categoryPro?id=${currentClickRow}`)
    } else if (rowObj.type == 10) {
      wxService.router(`/subPackage/page/pages/categoryPro/categoryPro?id=${currentClickRow}&type=pTag`)
    } 
  }
}
//导出
module.exports = {
  currentLinkRouter: currentLinkRouter
}